package students.stolerman;

import java.util.*;

import edu.drexel.cs.ai.othello.*;

/**
 * Ariel Stolerman's Othello agent<br>
 * CS510 Fall 2012, Drexel University
 *
 * @author Ariel Stolerman
 */
public class ArielOthelloPlayer extends OthelloPlayer
{
	/* =========================================================================
	 * Fields
	 * =========================================================================
	 */
	
	protected AlphaBetaSearch abSearch;
	
	
	/* =========================================================================
	 * Constructors
	 * =========================================================================
	 */
	
	/**
	 * Creates a new <code>ArielOthelloPlayer</code> with &alpha;-&beta;-pruning
	 * search.
	 */
	public ArielOthelloPlayer(String name)
	{
		super(name);
		abSearch = new AlphaBetaSearch();
	}
	
	
	/* =========================================================================
	 * Methods
	 * =========================================================================
	 */
	
	/**
	 * Returns the move chosen as best to be performed according to an &alpha;-
	 * &beta;-pruning search.
	 */
	public Square getMove(GameState currentState, Date deadline)
	{
		Square move = abSearch.alphaBeta(currentState, deadline);
		log("Example player is moving to " + move + "...");
		return move;
	}
	
	
	/* =========================================================================
	 * Main for testing
	 * =========================================================================
	 */
	
	public static void main(String[] args)
	{
		String[] othelloArgs = new String[]{
				"-nw",
				"-d",
				"30",
				ArielOthelloPlayer.class.getName(),
				RandomOthelloPlayer.class.getName()
		};
		Othello.main(othelloArgs);
	}
}
